/*
**	Imager-LP DLL Header
**		version 1.9.1
*/
/*
Copyright(c)2017-2022 ЃgXgE\tgEFAEVXe, All Rights Reserved.
*/

#ifndef	IMAGER_LP_DLL_H
#define	IMAGER_LP_DLL_H

#include <Windows.h>

#ifdef IMAGERDLL_EXPORTS
#define MLPAPI __declspec(dllexport)
#else
#define MLPAPI __declspec(dllimport)
#endif
#ifdef	WINAPI
#undef	WINAPI
#endif
#define	WINAPI	__stdcall

#include "MlpError.h"
#include "MlpDeclaration.h"

#ifdef	_UNICODE
#define	MlpInitialize			MlpInitializeW
#define	MlpLoadInitFile			MlpLoadInitFileW
#define	MlpLoadInitData			MlpLoadInitDataW
#define	MlpOpenDoc				MlpOpenDocW
#define	MlpOpenDocUsage			MlpOpenDocUsageW
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordW
#define	MlpValidateUserPassword		MlpValidateUserPasswordW
#define	MlpGetMetadataString	MlpGetMetadataStringW
#define	MlpSetCMYKProfile		MlpSetCMYKProfileW
#define	MlpSetRGBProfile		MlpSetRGBProfileW
#define	MlpPageToPict			MlpPageToPictW
#define	MlpPageToPictData		MlpPageToPictDataW
#define	MlpCreatePict			MlpCreatePictW
#define	MlpCreatePictData		MlpCreatePictDataW
#define	MlpConvertToTiff		MlpConvertToTiffW
#define	MlpRangeToTiff			MlpRangeToTiffW
#define	MlpCreateTiffRange		MlpCreateTiffRangeW
#define	MlpMultiPageToTiff		MlpMultiPageToTiffW
#define	MlpCreateTiffMulti		MlpCreateTiffMultiW
#define	MlpLicenseInfoStr		MlpLicenseInfoStrW
#define MlpPdfDocInfoEntry		MlpPdfDocInfoEntryW
#define MlpPanelToFile			MlpPanelToFileW
#define MlpSetDefaultFont		MlpSetDefaultFontW
#define MlpSetAlternateFont		MlpSetAlternateFontW
#define MlpSetAlternateFont2	MlpSetAlternateFont2W
#define MlpPaintRectToPanel2	MlpPaintRectToPanel2W
#define MlpSetImageWatermark	MlpSetImageWatermarkW
#define MlpSetFillTextWatermark	MlpSetFillTextWatermarkW
#define MlpSetStrokeTextWatermark MlpSetStrokeTextWatermarkW
#define MlpSimpleFontListGetName MlpSimpleFontListGetNameW
#else
#define	MlpInitialize			MlpInitializeA
#define	MlpLoadInitFile			MlpLoadInitFileA
#define	MlpLoadInitData			MlpLoadInitDataA
#define	MlpOpenDoc				MlpOpenDocA
#define	MlpOpenDocUsage			MlpOpenDocUsageA
#define	MlpValidateOwnerPassword	MlpValidateOwnerPasswordA
#define	MlpValidateUserPassword		MlpValidateUserPasswordA
#define	MlpGetMetadataString	MlpGetMetadataStringA
#define	MlpSetCMYKProfile		MlpSetCMYKProfileA
#define	MlpSetRGBProfile		MlpSetRGBProfileA
#define	MlpPageToPict			MlpPageToPictA
#define	MlpPageToPictData		MlpPageToPictDataA
#define	MlpCreatePict			MlpCreatePictA
#define	MlpCreatePictData		MlpCreatePictDataA
#define	MlpConvertToTiff		MlpConvertToTiffA
#define	MlpRangeToTiff			MlpRangeToTiffA
#define	MlpCreateTiffRange		MlpCreateTiffRangeA
#define	MlpMultiPageToTiff		MlpMultiPageToTiffA
#define	MlpCreateTiffMulti		MlpCreateTiffMultiA
#define	MlpLicenseInfoStr		MlpLicenseInfoStrA
#define MlpPdfDocInfoEntry		MlpPdfDocInfoEntryA
#define MlpPanelToFile			MlpPanelToFileA
#define MlpSetDefaultFont		MlpSetDefaultFontA
#define MlpSetAlternateFont		MlpSetAlternateFontA
#define MlpSetAlternateFont2	MlpSetAlternateFont2A
#define MlpPaintRectToPanel2	MlpPaintRectToPanel2A
#define MlpSetImageWatermark	MlpSetImageWatermarkA
#define MlpSetFillTextWatermark	MlpSetFillTextWatermarkA
#define MlpSetStrokeTextWatermark MlpSetStrokeTextWatermarkA
#define MlpSimpleFontListGetName MlpSimpleFontListGetNameA
#endif

#ifdef	__cplusplus
extern "C" {
#endif

/**/
MLPAPI int WINAPI MlpInitializeW(const wchar_t *license);
MLPAPI int WINAPI MlpInitializeA(const char *license);
MLPAPI void WINAPI MlpUninitialize();

/*f[^*/
MLPAPI int WINAPI MlpLoadInitFileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpLoadInitFileA(const char *fileName);
MLPAPI int WINAPI MlpLoadInitDataA(const char *dta, int len);

/*I[v*/
MLPAPI int WINAPI MlpOpenDocW(const wchar_t *fileName, const wchar_t *ownerPassword, const wchar_t *userPassword);
MLPAPI int WINAPI MlpOpenDocA(const char *fileName, const char *ownerPassword, const char *userPassword);
MLPAPI int WINAPI MlpOpenDocUsageW(const wchar_t *fileName, const wchar_t *password, int usage);
MLPAPI int WINAPI MlpOpenDocUsageA(const char *fileName, const char *password, int usage);
MLPAPI int WINAPI MlpOpenMemDoc(unsigned char *data, size_t len,  const char *owner_pw, const char *user_pw);
MLPAPI int WINAPI MlpOpenMemDocUsage(unsigned char *data, size_t len, const char *pass, int usage);
MLPAPI void WINAPI MlpCloseDoc();

/*Cu*/
MLPAPI int WINAPI MlpGetLibraryInfo(int cmd, ...);
MLPAPI void WINAPI MlpShowLicenseInfo();
MLPAPI int WINAPI MlpLicenseInfoStrA(char *licenseStrPtr);
MLPAPI int WINAPI MlpLicenseInfoStr2A(char **licenseStrPtr);

/**/
MLPAPI int WINAPI MlpGetDocumentInfo(int cmd, ...);
MLPAPI int WINAPI MlpPageCount();
MLPAPI int WINAPI MlpGetPageRotation(int pageNum, int *rotate);
MLPAPI int WINAPI MlpGetPageBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPageRawBoundary(int pageNum, int kind, float *userUnit, float *left, float *bottom, float *right, float *top);
MLPAPI int WINAPI MlpGetPicturePixel(int pageNum, int *x, int *y);
MLPAPI int WINAPI MlpGetPicturePixelX(int pageNum);
MLPAPI int WINAPI MlpGetPicturePixelY(int pageNum);
MLPAPI int WINAPI MlpGetMetadata(unsigned char **data);
MLPAPI int WINAPI MlpGetMetadataStringA(char **data);
MLPAPI int WINAPI MlpGetMetadataStringW(wchar_t **data);
MLPAPI int WINAPI MlpRemoveMetadata();
MLPAPI int WINAPI MlpSimpleFontListGetNameA(int number, char** name, int *embedFlag, int *fontType);
MLPAPI int WINAPI MlpSimpleFontListGetNameW(int number, wchar_t** name, int *embedFlag, int *fontType);

MLPAPI int WINAPI MlpMetadataDump();						//^f[^_v
MLPAPI int WINAPI MlpMetadataDumpToFile(char *filename);
MLPAPI int WINAPI MlpMetadataDumpToString(wchar_t**xmp);

MLPAPI METADATA_HANDLE WINAPI MlpGetMetadataInterface();	//^f[^ C^[tF[X擾 (݂PDFp)
MLPAPI void WINAPI MlpFinishMetadataInterface();			//^f[^ C^[tF[XS폜
MLPAPI int WINAPI MlpMetadataFindProperty(wchar_t *propName, MlpMetadataProperty **propertyValue);
MLPAPI MlpFormData WINAPI MlpInteractiveFormFirstData();
MLPAPI MlpFormData WINAPI MlpInteractiveFormNextData();

/*^f[^ C^[tF[X*/
MLPAPI void WINAPI MetadataCloseInterface(METADATA_HANDLE);	//^f[^ C^[tF[X폜(QƂ)
MLPAPI int WINAPI MetadataDump(METADATA_HANDLE);		//^f[^_v
MLPAPI int WINAPI MetadataDumpToFile(METADATA_HANDLE, char *filename);
MLPAPI int WINAPI MetadataDumpToString(METADATA_HANDLE, wchar_t**xmp);
MLPAPI int WINAPI MetadataFindProperty(METADATA_HANDLE, wchar_t *propName, MlpMetadataProperty **propertyValue);

MLPAPI int WINAPI MlpGetCid0GlyphMode();
MLPAPI int WINAPI MlpPrintRestriction();

/*XMPC^[tF[X*/
MLPAPI XMP_TK_HANDLE WINAPI MlpGetXmpInterface();
MLPAPI int WINAPI XmpDocumentToFile(XMP_TK_HANDLE h, const char *fileName);
MLPAPI void WINAPI XmpCloseInterface(XMP_TK_HANDLE);
MLPAPI int WINAPI XmpDoesPropertyExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDoesSimplePropertyExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDoesArrayPropertyExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDoesArrayItemExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex);
MLPAPI int WINAPI XmpDoesStructPropertyExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDoesStructFieldExist(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName);
MLPAPI int WINAPI XmpGetPropertyDate(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, time_t*);
MLPAPI int WINAPI XmpGetSimpleProperty(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, char **simpleValue);
MLPAPI int WINAPI XmpGetArrayItem(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex, char **arrayValue);
MLPAPI int WINAPI XmpCountArrayItems(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpGetStructField(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName, char **fieldValue);
MLPAPI int WINAPI XmpSetSimpleProperty(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, const char *simpleValue);
MLPAPI int WINAPI XmpSetSimplePropertyCurrentDate(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpSetSimplePropertyDate(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, time_t sourceTime);
MLPAPI int WINAPI XmpSetArrayItem(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex, const char *arrayItemValue);
MLPAPI int WINAPI XmpAppendArrayItem(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, unsigned long arrayOptions, const char *value);
MLPAPI int WINAPI XmpSetStructField(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName, const char *value);
MLPAPI int WINAPI XmpDeleteProperty(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDeleteSimpleProperty(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName);
MLPAPI int WINAPI XmpDeleteArrayItem(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, int itemIndex);
MLPAPI int WINAPI XmpDeleteStructField(XMP_TK_HANDLE, const char *namespaceURI, const char *propertyName, const char *fieldUri, const char *fieldName);
MLPAPI int WINAPI XmpDumpObjectToConsole(XMP_TK_HANDLE);
MLPAPI int WINAPI XmpDumpObjectToFile(XMP_TK_HANDLE, const char *outputFileName);
MLPAPI int WINAPI XmpDumpObjectToChar(XMP_TK_HANDLE, char **outData);
MLPAPI int WINAPI XmpUpdateDocument(XMP_TK_HANDLE);
MLPAPI int WINAPI XmpRegisterNamespace(XMP_TK_HANDLE, const char *namespaceURI, const char *suggestedPrefix, char **registerdPrefix);
MLPAPI long WINAPI XmpGetLastError(XMP_TK_HANDLE, char **message);

/*ݒ*/
MLPAPI int WINAPI MlpSetPicturec(int opt, int val);
MLPAPI int WINAPI MlpSetPicture(int opt, ...);
MLPAPI int WINAPI MlpSetPictureSize(int x, int y, int unit);
MLPAPI int WINAPI MlpSetPictureRGB();
MLPAPI int WINAPI MlpSetPictureCMYK();
MLPAPI int WINAPI MlpSetPictureGray();
MLPAPI int WINAPI MlpSetPictureBW();
MLPAPI int WINAPI MlpSetPictureDither();
MLPAPI int WINAPI MlpSetPictureFaxG3();
MLPAPI int WINAPI MlpSetPictureFaxG4();
MLPAPI int WINAPI MlpSetPictureResolution(int dpi);
MLPAPI int WINAPI MlpSetPictureQuality(int quality);
MLPAPI int WINAPI MlpSetPicturePixelX(int x);
MLPAPI int WINAPI MlpSetPicturePixelY(int y);
MLPAPI int WINAPI MlpSetCanvasSize(int x, int y);
MLPAPI int WINAPI MlpSetCanvasOrigin(int org);
MLPAPI int WINAPI MlpSetTiffCompress(int mode);
MLPAPI int WINAPI MlpSetEnableAntialis();
MLPAPI int WINAPI MlpSetDisableAntialis();
MLPAPI int WINAPI MlpSetFillPathAAEnable();
MLPAPI int WINAPI MlpSetFillPathAADisable();
MLPAPI int WINAPI MlpSetCid0GlyphMode(int mode);
MLPAPI int WINAPI MlpSetPictureBufSize(int mb);
MLPAPI int WINAPI MlpSetIncrementalUpdate(int flag);

/*pX[h*/
MLPAPI int WINAPI MlpValidateOwnerPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateOwnerPasswordW(const wchar_t *pass);
MLPAPI int WINAPI MlpValidateUserPasswordA(const char *pass);
MLPAPI int WINAPI MlpValidateUserPasswordW(const wchar_t *pass);

/*R[obN*/
MLPAPI int WINAPI MlpSetCallbackFunc(int mode, int opt, void *function);

/*J[vt@C*/
MLPAPI int WINAPI MlpSetCMYKProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetCMYKProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetRGBProfileW(const wchar_t *fileName);
MLPAPI int WINAPI MlpSetRGBProfileA(const char *fileName);
MLPAPI int WINAPI MlpSetColorConversion(int color_convert_direction, int flag);
MLPAPI int WINAPI MlpSetColorConvertForImage(int color_convert_direction, int flag);	/*݊p*/
MLPAPI int WINAPI MlpUnuseColorProfile();

/*tHg*/
MLPAPI int WINAPI MlpSetDefaultFontW(const wchar_t *defaultFont);
MLPAPI int WINAPI MlpSetDefaultFontA(const char *defaultFont);
MLPAPI int WINAPI MlpSetAlternateFontW(const wchar_t *org, const wchar_t *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFontA(const char *org, const char *alt, int always);
MLPAPI int WINAPI MlpSetAlternateFont2W(const wchar_t *org, const wchar_t *alt, const wchar_t *weight, const wchar_t *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFont2A(const char *org, const char *alt, const char *weight, const char *style, int always, int replace);
MLPAPI int WINAPI MlpSetAlternateFontExW(const wchar_t *org, const wchar_t *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_italic, int weight, int style, int variant, Matrix *transform);
MLPAPI int WINAPI MlpSetAlternateFontExA(const char *org, const char *alt, int always, int replace, int replace_on_render2, int alt_bold, int alt_italic, int weight, int style, int variant, Matrix *transform);

/*EH[^[}[N*/
MLPAPI int WINAPI MlpSetImageWatermarkW(const wchar_t *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetImageWatermarkA(const char *fileName, int x_position, int y_position, int z_position, float x_scale, float y_scale, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *color, float alpha);
MLPAPI int WINAPI MlpSetFillTextWatermarkA(const char *text, const char *fontName, int x_position, int y_position, int z_position, float fontSize, const char *color, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkW(const wchar_t *text, const wchar_t *fontName, int x_position, int y_position, int z_position, float fontSize, const wchar_t *color, float alpha);
MLPAPI int WINAPI MlpSetStrokeTextWatermarkA(const char *text, char const *fontName, int x_position, int y_position, int z_position, float fontSize, const char *color, float alpha);
MLPAPI int WINAPI MlpClearWatermarkData();


/*摜*/
MLPAPI int WINAPI MlpPageToPictW(int pageNumber, int dpi, int quality, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpPageToPictA(int pageNumber, int dpi, int quality, const char *outputFilePath);
MLPAPI int WINAPI MlpPageToPictDataW(int pageNumber, int dpi, int quality, const wchar_t *outputImageFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpPageToPictDataA(int pageNumber, int dpi, int quality, const char *outputImageFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpCreatePictW(int pageNumber, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictA(int pageNumber, const char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictDataW(int pageNumber, const wchar_t *outputFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpCreatePictDataA(int pageNumber, const char *outputFormat, unsigned int *len, unsigned char **datap);
MLPAPI int WINAPI MlpRangeToTiffW(int startPageNum, int endPageNum, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpRangeToTiffA(int startPageNum, int endPageNum, int dpi, const char *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayW(int pageNumArray[], int length, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreatePictPageArrayA(int pageNumArray[], int length, const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiW(const wchar_t *pageList, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffMultiA(const char *pageList, const char *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffW(const wchar_t *pageList, int dpi, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpMultiPageToTiffA(const char *pageList, int dpi, const char *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeW(int startPageNum, int endPageNum, const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpCreateTiffRangeA(int startPageNum, int endPageNum, const char *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffW(const wchar_t *outputFilePath);
MLPAPI int WINAPI MlpConvertToTiffA(const char *outputFilePath);

/*摜f[^*/
MLPAPI int WINAPI MlpCreatePictBufPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpCreatePictBufPageRange(int firstPageNumber, int lastPageNumber);
MLPAPI int WINAPI MlpCreatePictBufPageArray(int pages[], int len);
MLPAPI int WINAPI MlpCreatePictMem(int pageNumber);

/*摜f[^擾ƊJ*/
MLPAPI int WINAPI MlpGetPictFromMem(unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpGetPictFromMemIndex(int index, unsigned char **pixels, int *width, int *height, int *nOfColors, int *pageNumber);
MLPAPI int WINAPI MlpGetPictFromMemPage(int pageNumber, unsigned char **pixels, int *width, int *height, int *nOfColors);
MLPAPI int WINAPI MlpFreePictMem();

/*C[(OCG)*/
MLPAPI int WINAPI MlpGetOcgCount();
MLPAPI int WINAPI MlpGetOcgData(MlpOcgData *data[]);
MLPAPI int WINAPI MlpGetOcgUsage(MlpOcgUsage *usage[]);
MLPAPI int WINAPI MlpSetOcgState(MlpOcgData data[]);
MLPAPI int WINAPI MlpSetOcgStateU(MlpOcgUsage data[]);

/*Text Widget*/
MLPAPI int WINAPI MlpSetTextWidgetMultilineFontSize(float size);
MLPAPI float WINAPI MlpGetTextWidgetMultilineFontSize();
MLPAPI int WINAPI MlpSetTextWidgetMultilineUseLastSize(int use);
MLPAPI int WINAPI MlpGetTextWidgetMultilineUseLastSize();

/* pl */
MLPAPI int WINAPI MlpCreatePanel(int width, int height, int colorspace);
MLPAPI int WINAPI MlpClearPanel();
MLPAPI int WINAPI MlpFreePanel();
MLPAPI int WINAPI MlpPanelToFileA(const char *filePath);
MLPAPI int WINAPI MlpPanelToFileW(const wchar_t *filePath);
MLPAPI int WINAPI MlpMemPictToPanel(int x, int y, float alpha);
MLPAPI int WINAPI MlpMemPictToPanelBBox(int panel_xpos, int panel_ypos, float alpha, int bbox_xpos, int bbox_ypos, int bbox_width, int bbox_height);
MLPAPI int WINAPI MlpPaintRectToPanel(int xpos, int ypos, int width, int height, int lineWidth, unsigned char color[]);
MLPAPI int WINAPI MlpPaintRectToPanel2A(int xpos, int ypos, int width, int height, int lineWidth, char *color);
MLPAPI int WINAPI MlpPaintRectToPanel2W(int xpos, int ypos, int width, int height, int lineWidth, wchar_t *color);

/*t[*/
MLPAPI int WINAPI MlpSetPictureAddFrame(int flag);
MLPAPI int WINAPI MlpSetPictureFrameWidth(int width);
MLPAPI int WINAPI MlpSetPictureFrameRGB(float red, float green, float blue);
MLPAPI int __stdcall MlpSetPictureFrameGray(float gray);
MLPAPI int __stdcall MlpSetPictureFrameAlpha(float alpha);

/**/
MLPAPI int WINAPI MlpPrsGetFontInfo(PrsFontName **fontNameArray, int *len);
MLPAPI int WINAPI MlpPrsGetFontInfoWithTr(PrsFontName **fontNameArray, int *len);

/*IuWFNgo*/
MLPAPI int WINAPI MlpGetFirstImageResource(void);

/*PrimitiveC^[tF[X*/
MLPAPI PRIMITIVE_HANDLE WINAPI MlpGetPrimitiveInterface();
MLPAPI void WINAPI MlpFinishPrimitiveInterface();
MLPAPI void WINAPI PrmCloseInterface(PRIMITIVE_HANDLE);

MLPAPI int WINAPI PrmShowXref(PRIMITIVE_HANDLE);
MLPAPI int WINAPI PrmShowTrailer(PRIMITIVE_HANDLE, int pretty);
MLPAPI int WINAPI PrmShowCatalog(PRIMITIVE_HANDLE, int pretty);
MLPAPI int WINAPI PrmShowDocumentInformation(PRIMITIVE_HANDLE, int pretty);
MLPAPI int WINAPI PrmShowPageTree(PRIMITIVE_HANDLE, int pretty);
MLPAPI int WINAPI PrmShowIndirectObject(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty);
MLPAPI int WINAPI PrmShowIndirectObjectWithStream(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty, int ascii);
MLPAPI int WINAPI PrmShowStream(PRIMITIVE_HANDLE, unsigned int objectNumber);

MLPAPI int WINAPI PrmStringXref(PRIMITIVE_HANDLE, char **data);
MLPAPI int WINAPI PrmStringTrailer(PRIMITIVE_HANDLE, int pretty, char **data);
MLPAPI int WINAPI PrmStringCatalog(PRIMITIVE_HANDLE, int pretty, char **data);
MLPAPI int WINAPI PrmStringDocumentInformation(PRIMITIVE_HANDLE, int pretty, char **data);
MLPAPI int WINAPI PrmStringPageTree(PRIMITIVE_HANDLE, int pretty, char **data);
MLPAPI int WINAPI PrmStringIndirectObject(PRIMITIVE_HANDLE, unsigned int objectNumber, int pretty, char **data);
MLPAPI int WINAPI PrmStringStream(PRIMITIVE_HANDLE, unsigned int objectNumber, char **data);

MLPAPI int WINAPI PrmIndirectObjectHasStream(PRIMITIVE_HANDLE, unsigned int objectNumber);
MLPAPI int WINAPI PrmGetXrefOffset(PRIMITIVE_HANDLE);
MLPAPI int WINAPI PrmIsXrefTable(PRIMITIVE_HANDLE);
MLPAPI int WINAPI PrmIsXrefStream(PRIMITIVE_HANDLE, int* num, int* gen);
MLPAPI int WINAPI PrmXrefTable(PRIMITIVE_HANDLE, PrmDocumentXref** data);
MLPAPI int WINAPI PrmXrefStream(PRIMITIVE_HANDLE, PrmDocumentXref** data);

MLPAPI PrmObjectHandle WINAPI PrmObjectHandleTrailer(PRIMITIVE_HANDLE);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleCatalog(PRIMITIVE_HANDLE);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandlePageTree(PRIMITIVE_HANDLE);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandlePage(PRIMITIVE_HANDLE, int pageNumber);
MLPAPI int WINAPI PrmObjectHandleGetStream(PRIMITIVE_HANDLE, PrmObjectHandle, char **Streamdata);
MLPAPI int WINAPI PrmObjectHandleSetStream(PRIMITIVE_HANDLE, PrmObjectHandle, char *data, size_t len);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleIndirect(PRIMITIVE_HANDLE, unsigned int objectNumber);
MLPAPI int WINAPI PrmObjectHandleLength(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI int WINAPI PrmMaxObjectNumber(PRIMITIVE_HANDLE);

MLPAPI int WINAPI PrmObjectHandleDictionaryLength(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryKey(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, unsigned int index);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryValue(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, unsigned int index);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryByString(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, const char *key);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleDictionaryByObject(PRIMITIVE_HANDLE, PrmObjectHandle dictionaryObject, PrmObjectHandle key);
MLPAPI int WINAPI PrmObjectHandleArrayLength(PRIMITIVE_HANDLE, PrmObjectHandle arryObject);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleArrayValue(PRIMITIVE_HANDLE, PrmObjectHandle arryObject, unsigned int index);
MLPAPI int WINAPI PrmObjectHandleReferenceToNumber(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI int WINAPI PrmObjectHandleReferenceToGeneration(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI PrmObjectHandle WINAPI PrmObjectHandleReferenceToObject(PRIMITIVE_HANDLE, PrmObjectHandle);

MLPAPI int WINAPI PrmObjectHandleToBool(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI int WINAPI PrmObjectHandleToInt(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI float WINAPI PrmObjectHandleToReal(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI char* WINAPI PrmObjectHandleToStr(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI char* WINAPI PrmObjectHandleToName(PRIMITIVE_HANDLE, PrmObjectHandle);
MLPAPI int WINAPI PrmShowObjectHandle(PRIMITIVE_HANDLE, PrmObjectHandle, int resolve, int stream, int pretty);
MLPAPI int WINAPI PrmStringObjectHandle(PRIMITIVE_HANDLE, PrmObjectHandle, int resolve, int stream, int pretty, char **data);

/*
**T|[g֐
*/

/*摜֘A*/
MLPAPI int WINAPI MlpCreatePngFromPixels(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);
MLPAPI int WINAPI MlpCreatePngFromPixelsWAlpha(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);
MLPAPI int WINAPI MlpCreateJpegFromPixels(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);
MLPAPI int WINAPI MlpCreateTiffFromPixels(unsigned char *pixels, int width, int height, int n_of_colors, const char *fileName);
MLPAPI size_t WINAPI MlpPanelStorage(unsigned char **data);	/*pl̃f[^ƃTCY߂*/

/*J@\*/
MLPAPI void WINAPI MlpShowXref();
MLPAPI int WINAPI MlpShowTrailer(int pretty);
MLPAPI int WINAPI MlpShowCatalog(int pretty);
MLPAPI int WINAPI MlpShowDocumentInformation(int pretty);
MLPAPI int WINAPI MlpShowPageTree(int pretty);
MLPAPI int WINAPI MlpShowIndirectObj(unsigned int number, int pretty);
MLPAPI int WINAPI MlpShowIndirectObjWithStream(unsigned int number, int pretty, int ascii);
MLPAPI int WINAPI MlpShowStream(unsigned int number);
MLPAPI int WINAPI MlpStringXref(char **data);
MLPAPI int WINAPI MlpStringTrailer(int pretty, char **data);
MLPAPI int WINAPI MlpStringCatalog(int pretty, char **data);
MLPAPI int WINAPI MlpStringDocumentInformation(int pretty, char **data);
MLPAPI int WINAPI MlpStringPageTree(int pretty, char **data);
MLPAPI int WINAPI MlpStringIndirectObj(unsigned int number, int pretty, char **data);
MLPAPI int WINAPI MlpStringStream(unsigned int number, char **data);

MLPAPI int WINAPI MlpIndirectObjectHasStream(unsigned int number);
MLPAPI int WINAPI MlpGetXrefOffset();
MLPAPI int WINAPI MlpIsXrefTable();
MLPAPI int WINAPI MlpIsXrefStream(int *number, int *generation);
MLPAPI int WINAPI MlpXrefTable(PrmDocumentXref**);
MLPAPI int WINAPI MlpXrefStream(PrmDocumentXref**);

MLPAPI PrmObjectHandle WINAPI MlpObjectHandleTrailer();
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleCatalog();
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleIndirect(unsigned int number);
MLPAPI int WINAPI MlpObjectHandleLength(PrmObjectHandle);

MLPAPI int WINAPI MlpObjectHandleDictionaryLength(PrmObjectHandle dictionaryObject);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleDictionaryKey(PrmObjectHandle dictionaryObject, unsigned int index);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleDictionaryValue(PrmObjectHandle dictionaryObject, unsigned int index);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleDictionaryByString(PrmObjectHandle dictionaryObject, const char *key);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleDictionaryByObject(PrmObjectHandle dictionaryObject, PrmObjectHandle key);
MLPAPI int WINAPI MlpObjectHandleArrayLength(PrmObjectHandle arrayObject);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleArrayValue(PrmObjectHandle arrayObject, unsigned int index);
MLPAPI int WINAPI MlpObjectHandleReferenceToNumber(PrmObjectHandle);
MLPAPI int WINAPI MlpObjectHandleReferenceToGeneration(PrmObjectHandle obj);
MLPAPI PrmObjectHandle WINAPI MlpObjectHandleReferenceToObject(PrmObjectHandle);

MLPAPI int WINAPI MlpObjectToBool(PrmObjectHandle);
MLPAPI int WINAPI MlpObjectToInt(PrmObjectHandle);
MLPAPI float WINAPI MlpObjectToReal(PrmObjectHandle);
MLPAPI char* WINAPI MlpObjectToStr(PrmObjectHandle);
MLPAPI char* WINAPI MlpObjectToName(PrmObjectHandle);

MLPAPI int WINAPI MlpShowObjectHandle(PrmObjectHandle, int resolve, int stream, int pretty);
MLPAPI int WINAPI MlpStringObjectHandle(PrmObjectHandle, int resolve, int stream, int pretty, char **data);

#ifdef	__cplusplus
}
#endif

#endif	/*IMAGER_LP_DLL_H*/
